set gamble(jackver) "JackJack (Rev 5) by GOD-EMPEROR (2002)"

set gamble(jstopdeal) 17 ;# value at which dealer stays
set gamble(jlow) 50      ;# minimum bet value
set gamble(jhigh) 250    ;# maximum bet value

set 52deck "32 33 34 35 36 37 38 39 30 3J 3Q 3K 31 12 13 14 15 16 17 18 19 10 1J 1Q 1K 11 42 43 44 45 46 47 48 49 40 4J 4Q 4K 41 22 23 24 25 26 27 28 29 20 2J 2Q 2K 21"
if ![info exists gamble(jjadeck)] {set gamble(jjadeck) [shuffle5 "$52deck $52deck"]}
proc showcard {card} {
	set str "" ; set val ""
	set suit [string index $card 0]
	set face [string index $card 1]
	switch $suit {
		1 {set suit "Spades"}
		2 {set suit "Clubs"}
		3 {set suit "Hearts"}
		4 {set suit "Diamonds"}
	}
	switch $face {
		1 {set face "Ace"}
		J {set face "Jack"}
		Q {set face "Queen"}
		K {set face "King"}
		0 {set face "10"}
	}
	return "$face of $suit"
}

proc calccard {card} {
	set value [string index $card 1]
	switch $value {
		1 {set value 11}
		J {set value 10}
		Q {set value 10}
		K {set value 10}
		0 {set value 10}
	}
	return $value
}
proc freshen {} {
  global gamble 52deck
  if {[string length $gamble(jjadeck)] < 20} {
    set newdecks [shuffle5 "$52deck $52deck"]
    append gamble(jjadeck) " $newdecks"
  }
}
proc jackalive {hand jhand idx} {
	global gamble
	if [info exists gamble($hand,boot)] {killtimer $gamble($hand,boot)}
	set gamble($hand,boot) [timer 10 "jackjack $jhand $idx &jackquit"]
}
proc jackinit {hand} {
	global gamble
	set gamble($hand,jdct) 0
	set gamble($hand,jpct) 0
	set gamble($hand,active) 1
}
proc jackhs {name {winc 0}} {
 set uN "" ; set dN "" 
 set wbuf [clock format [clock seconds] -format "%U"]
 set lines [jackardw]
 set dstamp [lindex $lines 0]
 if {$dstamp == $wbuf} {
  foreach line [lrange $lines 1 end] {
    set type ""
    foreach {type user score} $line {}
    if {$type == ""} {continue}
    switch $type {
     UP {
       lappend uN "$user $score"
     }
     DN {
       lappend dN "$user $score"
     }
    }
  }
  if {$winc < 0} {
    set winc [string trimleft $winc -]
    set pos [lsearch -regexp $uN "$name *"]
    if {$pos != -1} {
      set oldstat [lindex $uN $pos]
      set uN [lreplace $uN $pos $pos "$name [expr [lindex $oldstat 1] + $winc]"]
    } else {
      lappend uN "$name $winc"
    }
  } elseif {$winc > 0} {
    set pos [lsearch -regexp $dN "$name *"]
    if {$pos != -1} {
      set oldstat [lindex $dN $pos]
      set dN [lreplace $dN $pos $pos "$name [expr [lindex $oldstat 1] - $winc]"]
    } else {
      lappend dN "$name -$winc"
    }
  }
  set sun [llength $uN]
  if {$sun > 1} {set uN [intsort $uN 1]}
  if {$sun > 9} {set uN [lrange $uN 0 8]}
  set sun [llength $dN]
  if {$sun > 1} {set dN [intsort2 $dN 1]}
  if {$sun > 9} {set dN [lrange $dN 0 8]}
  foreach oon $uN {lappend wbuf "UP $oon"}
  foreach oon $dN {lappend wbuf "DN $oon"}
 } else {
   if [file exists "hiscore.jj"] {catch {file rename -force "hiscore.jj" "hiscore.old"}}
   if {$winc < 0} {
     lappend uN "$name [string trimleft $winc -]"
   } elseif {$winc > 0} {
     lappend dN "$name -$winc"
   }
 }
 jackardw $wbuf
 return $wbuf
}

bind chat - &jack* jackjack
proc jackjack {hand idx args} {
  if {[string first "@" $hand] != -1} {return}
  set idx [ssidx $hand]
  authchk $hand $idx
  global gamble
  set args [string tolower [lindex $args 0]]
#########putlog "$hand ($idx) $args"
  set cmd [string range [lindex $args 0] 5 end]
  set args [lindex $args 1]
#########putlog "/// $cmd ///"
  if {$cmd == "" || $cmd == "help"} {
	putdcc $idx ">>--\[ $gamble(jackver) \]--"
	putdcc $idx ">> rules of the game:"
	putdcc $idx ">-> basically Blackjack, with twists"
	putdcc $idx "> "
	putdcc $idx ">> payouts as follows:"
	putdcc $idx ">-> A pair of Jacks = win 5x your bet"
	putdcc $idx ">-> Beat the house = win 2x your bet"
	putdcc $idx ">-> Dealer wins = lose 1x your bet"
	putdcc $idx ">-> Pair of Aces = lose the bank"
	putdcc $idx ">-> Dealer/Player tie (except on 21) = push"
	putdcc $idx "> "
	putdcc $idx ">> type \"&jackscores\" to see this month's hiscores"
	putdcc $idx ">> type \"&jackbank <amount>\" to cash-in credits to play"
	putdcc $idx ">> type \"&jackplay\" to start a game"
	return
  }
  set user $hand
  set hand [authget $hand user]

  switch -- $cmd {
	bank {
		if ![info exists gamble($hand,active)] {putdcc $idx "> Bank: play a game of JackJack then come back" ; return}
		set maxdraw [expr $gamble(jhigh) * 10]
		set amt [getucreds $hand]
		if {$amt == -1} {set amt 1000 ; set gamble($hand,leech) 1} else {set gamble($hand,leech) 0}
		if {$args > $maxdraw} {putdcc $idx "> Bank: our withdrawl limit is $maxdraw, we are careful with your credits" ; return}
		if {![string is integer $args] || $args == "" || $args < 0} {putdcc $idx "> Bank: you have to specify the amount (MB) to withdraw, e.g. 1500, you have $amt in the account" ; return}
		if {$args > $amt} {putdcc $idx "> Bank: your available credits appear to be $amt, no withdrawl will occur" ; return}
		if {$gamble($hand,leech) == 0} {adjcreds $hand -[expr ($args + 10) * 1024]}
		if ![info exists gamble($hand,bank)] {set gamble($hand,bank) 0}
		incr gamble($hand,bank) $args
		if ![info exists gamble($hand,bankw)] {set gamble($hand,bankw) 0}
		incr gamble($hand,bankw) $args
		putdcc $idx "> Bank: your withdrawl of $args has been made, you have [getucreds $hand] credit remaining"
		return
	}
	play {
		if [info exists gamble($hand,active)] {putdcc $idx "> Dealer: you're sitting at the table, place a bet" ; return}
		freshen
		tsend chan 0 // "*** JackJack: $hand has joined in a game of JackJack, good luck! ***"
		putdcc $idx "> Dealer: welcome to JackJack, place your bet"
		putdcc $idx "> "
		putdcc $idx ">> commands:"
		putdcc $idx ">-> &jackbet <amount> - bet and deal"
		putdcc $idx ">-> &jackhit - ask for another card"
		putdcc $idx ">-> &jackstay - stand with your cards"
		putdcc $idx ">-> &jackquit - quit playing"
		putdcc $idx ">-> &jackstat - show your playing statistics"
		putdcc $idx "> "
		putdcc $idx ">> house rules:"
		putdcc $idx ">-> minimum bet $gamble(jlow), maximum bet $gamble(jhigh)"
		putdcc $idx ">-> can't quit until hand in progress is finished"
		set gamble($hand,jbet) 0
		set gamble($hand,wins) 0
		set gamble($hand,loss) 0
		set gamble($hand,active) 0
		if ![info exists gamble($hand,bank)] {set gamble($hand,bank) 0}
		jackalive $hand $user $idx
	}
	bet {
		freshen
		if ![info exists gamble($hand,active)] {putdcc $idx "> Dealer: can't bet until you join a game!" ; return}
		if ![info exists gamble($hand,bank)] {putdcc $idx "> Dealer: withdraw some credit from the bank - &jackbank" ; return}
		if {$gamble($hand,active) == 1} {putdcc $idx "> Dealer: you can't bet again, you're already in a game!" ; return}
		if ![string is integer $args] {putdcc $idx "> Dealer: try to bet a number, anywhere between $gamble(jlow) & $gamble(jhigh)!" ; return}
		if {$args < $gamble(jlow)} {putdcc $idx "> Dealer: JackJack isn't video poker, minimum bet is $gamble(jlow)" ; return}
		if {$args > $gamble(jhigh)} {putdcc $idx "> Dealer: house guidelines limit maximum bet to $gamble(jhigh), for your safety" ; return}
		if {$args > $gamble($hand,bank)} {putdcc $idx "> Dealer: your bank balance is getting low, too low to bet that" ; return}

		incr gamble($hand,jbet) $args
		incr gamble($hand,bank) -$args
		set gamble($hand,active) 1
		putdcc $idx "> Dealer: player bets $args"

		jackalive $hand $user $idx
		freshen
		jackinit $hand

		set cards [lrange $gamble(jjadeck) 0 3]
		set gamble(jjadeck) [lrange $gamble(jjadeck) 4 end]
		set pcard1 [lindex $cards 1]; set pcard2 [lindex $cards 3]; set dcard1 [lindex $cards 0]; set dcard2 [lindex $cards 2]
		set gamble($hand,jdealer) "[showcard $dcard1], [showcard $dcard2]"
		set dealerface "[showcard $dcard2]"
		set playerface "[showcard $pcard1], [showcard $pcard2]"
		incr gamble($hand,jdct) [calccard $dcard1]
		incr gamble($hand,jdct) [calccard $dcard2]
		incr gamble($hand,jpct) [calccard $pcard1]
		incr gamble($hand,jpct) [calccard $pcard2]
		set pcard1 [string index $pcard1 1]
		set pcard2 [string index $pcard2 1]
		set dcard1 [string index $dcard1 1]
		set dcard2 [string index $dcard2 1]
		set gamble($hand,active) 0
		if {$pcard1 == "J" && $pcard2 == "J"} {
			putdcc $idx "> Dealer: player gets a pair of Jacks - we call that a Jackpot!"
			set cred [expr $gamble($hand,jbet) * 5]
			incr gamble($hand,bank) $cred
			set gamble($hand,jbet) 0
			incr gamble($hand,wins)
		} elseif {$pcard1 == "1" && $pcard2 == "1"} {
			putdcc $idx "> Dealer: player gets a pair of Aces - there goes the bank!"
			set gamble($hand,bank) 0
			set gamble($hand,jbet) 0
			incr gamble($hand,loss)
		} elseif {$gamble($hand,jdct) == 21} {
			putdcc $idx "> Dealer: player is dealt $playerface"
			putdcc $idx "> Dealer: dealer has $gamble($hand,jdealer) for 21, house wins"
			set gamble($hand,jbet) 0
			incr gamble($hand,loss)
		} elseif {$gamble($hand,jpct) == 21} {
			putdcc $idx "> Dealer: player gets $playerface"
			putdcc $idx "> Dealer: player has 21, house loses"
			set cred [expr $gamble($hand,jbet) * 2]
			incr gamble($hand,bank) $cred
			set gamble($hand,jbet) 0
			incr gamble($hand,wins)
		} else {
			set gamble($hand,active) 1
			putdcc $idx "> Dealer: dealer has two cards, with $dealerface showing"
			putdcc $idx "> Dealer: player has $playerface for a total of $gamble($hand,jpct)"
		}
	}
	hit {
		freshen
		if ![info exists gamble($hand,active)] {putdcc $idx "> Dealer: so no playing, you want me to hit you?" ; return}
		if {$gamble($hand,active) == 0} {putdcc $idx "> Dealer: have you noticed I haven't dealt anything yet?" ; return}

		set card [lindex $gamble(jjadeck) 0]
		set gamble(jjadeck) [lrange $gamble(jjadeck) 1 end]
		set face [showcard $card]
		incr gamble($hand,jpct) [calccard $card]
		if {$gamble($hand,jpct) < 21} {
			putdcc $idx "> Dealer: player gets a $face for a total of $gamble($hand,jpct)"
		} elseif {$gamble($hand,jpct) == 21} {
			putdcc $idx "> Dealer: and with a $face player has a total of 21, player wins!"
			set cred [expr $gamble($hand,jbet) * 2]
			incr gamble($hand,bank) $cred
			set gamble($hand,jbet) 0
			incr gamble($hand,wins)
			set gamble($hand,active) 0
		} elseif {$gamble($hand,jpct) > 21} {
			putdcc $idx "> Dealer: player busts with $gamble($hand,jpct), the $face was too much"
			set gamble($hand,jbet) 0
			incr gamble($hand,loss)
			set gamble($hand,active) 0
		}
		jackalive $hand $user $idx
	}
	stay {
		freshen
		if ![info exists gamble($hand,active)] {putdcc $idx "> Dealer: I'm staying right here until you wanna play" ; return}
		if {$gamble($hand,active) == 0} {putdcc $idx "> Dealer: is this some new kind of game we're playing?" ; return}
		putdcc $idx "> Dealer: player stands at $gamble($hand,jpct)"
		jackalive $hand $user $idx
		jackdplay $hand $idx
	}
	quit {
		if ![info exists gamble($hand,active)] {putdcc $idx "> Dealer: instead of being a quitter, try playing a bit" ; return}
		if {$gamble($hand,active) == 1} {putdcc $idx "> Dealer: you can't run away until you finish your game" ; return}
		catch {killtimer $gamble($hand,boot)}
		if {$gamble($hand,wins) != 0 || $gamble($hand,loss) != 0} {
###putlog ">>> $gamble($hand,bankw)  withdrawls"
###putlog ">>> $gamble($hand,bank)  balance"
			set winc [expr $gamble($hand,bankw) - $gamble($hand,bank)]
			incr gamble($hand,bank)
			if {$winc > 0} {
	tsend chan 0 // "*** JackJack: $hand has quit JackJack, after dropping a humiliating $winc, Thanks for playing! ***"
	if {$gamble($hand,leech) == 0} {adjcreds $hand [expr $gamble($hand,bank) * 1024]}
			} elseif {$winc < 0} {
	tsend chan 0 // "*** JackJack: $hand has quit JackJack, and takes home [string trimleft $winc -] winnings, thanks for playing! ***"
	if {$gamble($hand,leech) == 0} {adjcreds $hand [expr $gamble($hand,bank) * 1024]}
			} else {
	tsend chan 0 // "*** JackJack: $hand has quit JackJack, and has successfully avoided gaining any credits! Wasn't that fun? ***"
			}
			set tN [lrange [jackhs $hand $winc] 1 end]
			if [valididx $idx] {
				putdcc $idx "> Dealer: come again sometime, persistence makes a winner"
				putdcc $idx "> "
				jackjack $user $idx &jackmojopuppy
				putdcc $idx "> " ; set tll [llength $tN]
				if {$tll != 0} {
					putdcc $idx ">>--\[ Top Winners \]--" ; set setu "UP" ; set x 1
					foreach item $tN {
						if {$item == ""} {break}
						set setc [lindex $item 0]
						set item [lrange $item 1 2]
						if {$setc != $setu} {
							putdcc $idx "> " ; set x 1 ; set setu "DN"
							putdcc $idx ">>--\[ Top Losers \]--"
						}
						set utem [fixlen "$x. [lindex $item 0]" 15]
						putdcc $idx ">-> $utem [fixlenr [lindex $item 1] 8]"
						incr x
					}
				} else {
					putdcc $idx "> No Scores yet"
				}
				putdcc $idx ">"
				putdcc $idx ">>--\[ $gamble(jackver) \]--"
			}
		} else {
			tsend chan 0 // "*** JackJack: $hand has quit JackJack, not having played, can we say chicken?! ***"
			if [valididx $idx] {
				putdcc $idx "> Dealer: you obviously have no balls to play"
				putdcc $idx "> "
				putdcc $idx ">>--\[ $gamble(jackver) \]--"
			}
	    	}
		array unset gamble "$hand,*"
######putlog "unsetting $item"
		return
	}
	scores {
		set tN [lrange [jackhs $hand] 1 end]
		putdcc $idx "> Dealer: hall of fame or hall of shame? you decide"
		putdcc $idx "> " ; set tll [llength $tN]
		if {$tll != 0} {
			putdcc $idx ">>--\[ Top Winners \]--" ; set setu "UP" ; set x 1
			foreach item $tN {
				if {$item == ""} {break}
				set setc [lindex $item 0]
				set item [lrange $item 1 2]
				if {$setc != $setu} {
					putdcc $idx "> " ; set x 1 ; set setu "DN"
					putdcc $idx ">>--\[ Top Losers \]--"
				}
				set utem [fixlen "$x. [lindex $item 0]" 15]
				putdcc $idx ">-> $utem [fixlenr [lindex $item 1] 8]"
				incr x
			}
		} else {
			putdcc $idx ">-> No Scores yet"
		}
		putdcc $idx "> "
		return
	}
	stat {
		if ![info exists gamble($hand,active)] {putdcc $idx "> Dealer: are you or are you not willing to play?" ; return}
		if {$gamble($hand,wins) == 0 && $gamble($hand,loss) == 0} {putdcc $idx "> Dealer: I see nothing on my scorecard about you" ; return}
		putdcc $idx "> Dealer: vanity is my favourite sin"
		putdcc $idx "> "
		jackjack $user $idx &jackmojopuppy
	}
	mojopuppy {
		putdcc $idx ">-> Good luck: $gamble($hand,wins)"
		putdcc $idx ">-> Bad luck: $gamble($hand,loss)"
		set hund [expr $gamble($hand,loss) + $gamble($hand,wins)]
		if {$hund > 0} {
			putdcc $idx ">-> Mojo efficiency: [expr {100 / $hund * $gamble($hand,wins)}]%"
		}
		return
	}
	default {return}
  }
  if {$gamble($hand,active) == 0} {
	putdcc $idx "> "
	putdcc $idx "> Bank: you have $gamble($hand,bank) available credits"
  }
  putlog "jackjack: completed"
}
proc jackdplay {hand idx} {
  global gamble
  putdcc $idx "> Dealer: dealer is holding $gamble($hand,jdealer)"
  for {set x 0} {$x < 4} {incr x} {
	if {$gamble($hand,jdct) >= $gamble(jstopdeal)} {break}
	set card [lindex $gamble(jjadeck) $x]
	incr gamble($hand,jdct) [calccard $card]
	putdcc $idx "> Dealer: dealer draws a [showcard $card], for a total of $gamble($hand,jdct)"
  }
  incr x
  set gamble(jjadeck) [lrange $gamble(jjadeck) $x end]
  if {$x == 3} {
    putdcc $idx "> Dealer: dealer stops at 5 cards with $gamble($hand,jdct)"
  }
  set boob [expr $gamble($hand,jdct) - $gamble($hand,jpct)]
  if {$boob == 0} {
	putdcc $idx "> Dealer: dealer stands, player has tied dealer at $gamble($hand,jdct)"
	putdcc $idx "> Dealer: bet is pushed to next round"
  } elseif {$boob < 0} {
	putdcc $idx "> Dealer: dealer stands, dealer has $gamble($hand,jdct)"
	putdcc $idx "> Dealer: player has $gamble($hand,jpct) against dealer's $gamble($hand,jdct), player wins"
	incr gamble($hand,bank) [expr $gamble($hand,jbet) * 2]
	incr gamble($hand,wins)
	set gamble($hand,jbet) 0
  } elseif {$boob > 0 && $gamble($hand,jdct) > 21} {
	putdcc $idx "> Dealer: dealer busts with $gamble($hand,jdct)"
	incr gamble($hand,bank) [expr $gamble($hand,jbet) * 2]
	incr gamble($hand,wins)
	set gamble($hand,jbet) 0
  } else {
	putdcc $idx "> Dealer: player has $gamble($hand,jpct), house wins with $gamble($hand,jdct)"
	incr gamble($hand,loss)
	set gamble($hand,jbet) 0
  }
  set gamble($hand,active) 0
}
proc jackardw {{wbuf ""}} {
	set of "1" ; set llist "" ; set filename "hiscore.jj"
	if [file exists $filename] {
		catch {open $filename r+} of
		if ![string match "file*" $of] {return "e"}
	} else {
		catch {open $filename w+} of
		if ![string match "file*" $of] {return "e"}
		puts $of ""
	}
	if {$wbuf == ""} {
		set size [file size $filename]
		if {$size > 1} {set llist [read $of $size]}
	} else {
		seek $of 0 ; foreach item $wbuf {puts $of $item}
	}
	close $of
	return [split $llist "\n"]
}

putlog "$gamble(jackver) loaded"