###############################################
#
#  This is a simple demonstration game addon
#  for Sitestat 5.0 -- GOD-EMPEROR (2002)
#
###############################################
#
#  calculations: pick the card, guess the card
#
###############################################
#
#  Standard 52 card deck, the first digit is 
#  the suit, second is the value, 1 = Ace
#
set deckofcards "32 33 34 35 36 37 38 39 30 3J 3Q 3K 31 12 13 14 15 16 17 18 19 10 1J 1Q 1K 11 42 43 44 45 46 47 48 49 40 4J 4Q 4K 41 22 23 24 25 26 27 28 29 20 2J 2Q 2K 21"
#
#  Using a function in ss5-main we shuffle them
#
set deckofcards [shuffle5 $deckofcards]
#
###############################################
#
#  Some standard card functions for determining
#  face, suit or value
#
proc showcardface {card} {
	set str "" ; set val ""
	set suit [string index $card 0]
	set face [string index $card 1]
	switch $suit {
		1 {set suit "Spades"}
		2 {set suit "Clubs"}
		3 {set suit "Hearts"}
		4 {set suit "Diamonds"}
	}
	switch $face {
		1 {set face "Ace"}
		J {set face "Jack"}
		Q {set face "Queen"}
		K {set face "King"}
		0 {set face "10"}
	}
	return "$face of $suit"
}
proc showcardfacevalue {card} {
	set value [string index $card 1]
	switch $value {
		1 {set value 11}
		J {set value 10}
		Q {set value 10}
		K {set value 10}
		0 {set value 10}
	}
	return $value
}
#
###############################################
#
#  Here we make the command handler proc...
#  We want to listen for everything starting
#  with "&demo" e.g &demohelp
#
#  note: binding flags don't apply to chat
#
bind chat - &demo* demoproc
#
#  We then need the proc and a few checks to
#  determine if the user is authenticated via
#  Sitestat functions
#
proc demoproc {hand idx args} {
	global deckofcards gamble
	set args [string tolower [lindex $args 0]]
	set idx [ssidx $hand]
	authchk $hand $idx
	set user [authget $hand user]
#
#  We need to strip the &demo from the trigger
#  and the fastest way is a string range, and
#  its a good idea to chop off the trigger from
#  args - if there will be any user given args
#
	set cmd [string range [lindex $args 0] 5 end]
	set args [lindex $args 1]
#
#  To handle the commandline, switching the
#  stripped trigger is the cleanest way
#
	
	switch -- $cmd {
		help {
		  putdcc $idx "-\[ This is Your Help \]-----------------"
		  putdcc $idx "&demoget -> picks a random card"
		  putdcc $idx "&demopick <number> -> try to choose a matching card"
		  putdcc $idx "&demohelp -> this help screen"
		  putdcc $idx "-*-*-"
		}
		get {
		  if [info exists gamble(demostage)] {
		    putdcc $idx "-\[ Card NOT Chosen \]-----------------"
		    putdcc $idx "you are already in a game" ; return
		  }
		  set card [lindex $deckofcards 0]
		  set suit [lindex [showcardface $card] 2]
		  putdcc $idx "-\[ Random Card Chosen \]-----------------"
		  putdcc $idx "You picked [showcardface $card], pick another of suit $suit"
		  set gamble($hand,democard) $suit
		  putdcc $idx "-*-*-"
		  set gamble(demostage) 1
		}
		pick {
		  if ![info exists gamble(demostage)] {
		    putdcc $idx "-\[ Card NOT Selected \]-----------------"
		    putdcc $idx "you are not in a game" ; return
		  }
		  if {$args > 0 && $args < 53} {
			set card [lindex $deckofcards $args]
			set suit [lindex [showcardface $card] 2]
			putdcc $idx "-\[ Card Selected \]-----------------"
			putdcc $idx "You picked [showcardface $card]"
			if {$gamble($hand,democard) == $suit} {
				putdcc $idx "Your cards are both $suit"
				adjcreds $user 50000
			} else {
				putdcc $idx "Your cards are different suits"
				adjcreds $user -50000
			}
			putdcc $idx "-*-*-"
			set deckofcards [shuffle5 $deckofcards]
			unset gamble($hand,democard)
			unset gamble(demostage)
		  } else {
			putdcc $idx "-\[ Card Selected \]-----------------"
			putdcc $idx "Pick a Number between 1 and 52"
			putdcc $idx "-*-*-"
		  }
		}
		default {}
	}
}
#
###############################################
#
#  Function calls of interest:
#
#  - authget <handle> <info> 
#   where info can be: user, group, index
#  - authset <handle> <info> 
#   where info can be: user, group, index
#  - adjcreds <user> <amount>
#   will give/take amount to/from ftp user
#  - ssidx <handle>
#   returns authenticated index of person
#
###############################################

putlog "Shitty Demo Game For Sitestat 5.0 by GOD-EMPEROR loaded"